from org.codehaus.jettison.json import JSONObject, JSONArray
import sys;
from utilities import Util

__name_att__ = None;

def _export(objid, parentrespath, name = ""):
  Util.pushPathElement('GenericClusterRoute')


  if parentrespath == "/":
    parentrespath = "";
  respath = "%(parentrespath)s/%(name)s" % { 'parentrespath':parentrespath, 'name':name }
  if not respath.startswith("/"):
    respath = "/" + respath;

  exportedObject = JSONObject();
  exportedObject.put("name", name);
  exportedObject.put("path", respath);
  exportedObject.put("teamMappings", JSONArray());
  exportedObject.put("inheritTeam", "true");
  exportedObject.put("description", "Discovered WebSphereGenericClusterRoute");
  exportedObject.put("roleName", "WebSphereGenericClusterRoute");

  roleProperties = JSONObject();

  Util.addAttributeToJsonIfNotNone(roleProperties, "websphere.genericclusterroute.genericserverclustername", objid, "genericServerClusterName","GenericClusterRoute");
  exportedObject.put("roleProperties", roleProperties);
  result = { 'object': exportedObject, 'respath':respath }
  extraObjects = [];
  if len(extraObjects) != 0:
    result['extraObjects'] = extraObjects;
  Util.popPathElement('GenericClusterRoute');
  return result;



def create(parentid, jsonobject):
  Util.pushPathElement('GenericClusterRoute')
  if not jsonobject.has("roleProperties"):
    raise Exception("GenericClusterRoute resource has no role properties!");

  roleProperties = jsonobject.getJSONObject("roleProperties");

  properties = [];
  Util.addIfNotNone(properties, "genericServerClusterName", roleProperties.optString("websphere.genericclusterroute.genericserverclustername", None));
  print "Creating GenericClusterRoute with attributes";
  for prop in properties:
    print "%(name)s = %(value)s" % { 'name': prop[0], 'value': prop[1] };
  objid = Util.create("GenericClusterRoute", parentid, properties);
  Util.popPathElement('GenericClusterRoute');

def update(objid,jsonobject):
  Util.pushPathElement('GenericClusterRoute')
  if not jsonobject.has("roleProperties"):
    raise Exception("GenericClusterRoute resource has no role properties!");

  roleProperties = jsonobject.getJSONObject("roleProperties");

  atts = [];
  Util.addAttIfChanged(objid, atts, roleProperties.optString("websphere.genericclusterroute.genericserverclustername", None), "genericServerClusterName","GenericClusterRoute");
  if len(atts) != 0:
    print "Modifying GenericClusterRoute with attributes:"
    for prop in atts:
      print "%(name)s = %(value)s" % { 'name': prop[0], 'value': prop[1] };

    Util.modify(objid, atts);
  else:   
    print "GenericClusterRoute configuration up to date.";

  Util.popPathElement('GenericClusterRoute');
